FILENAME=$1
if ! [ -f $FILENAME ] 
then 
	echo "$FILENAME : file not found "
	exit 1
fi
if ! echo $FILENAME | grep -q '.s$' 
then 
	echo "$FILENAME : must end with ext .s "
	exit 1
fi
if ! nasm -f elf $FILENAME 
then 
	echo "Program did not assemble";exit 1
fi
OBJNAME=`echo $FILENAME |sed -e 's/\.s$/\.o/'`
BINNAME=`echo $FILENAME |sed -e 's/\.s$/\.bin/'`
objcopy -O binary $OBJNAME $BINNAME 
if [ -x tools/pad ] 
then 
	tools/pad -ns $BINNAME 1000
fi
exit 0
