#ifndef _DEBUGGER_H
#define _DEBUGGER_H
#include <tss.h>
#include <defs.h>
#include <gdt.h>
#include <printk.h>
#include <kalloc.h>
#include <idt.h>
#include <stdtypes.h>
#include <floppy.h>
#include <string.h>
#include <asm.h>
#define ILLEGAL_ARGS {\
	printk("\n Illegal arguments entered \n");\
	continue;\
	}
#define CHECK_ARGS_LEN(x) if(numWords!=(x+1)){\
	printk("\n Illegal no. of arguments entered \n");\
	continue;\
	}
#define GET_ARGS(x) for(_i=1;_i<=(x);_i++) {args[i]=atoi(ptrArray[i]);}
#define init_prog_seg() threadCode.npage=-1;threadData.npage=-1;threadStack.npage=-1;
#define BLOCK2PAGE(x) ((x)>>3)+1
#define check_load() if(!progLoaded) {printk("\n No program loaded till now !!"); continue;}
#define KERNEL_TYPE -1
#define USER_PRIV 0
#define USER_UNPRIV 3
/*Don't dare mess up the order here .  */
struct savedData{
	dword_t new_ss,gs,fs,es,ds; /*Note these are doubles with low bits zero */
	dword_t di,si,bp,old_sp,bx,dx,cx,ax;
	/*dword_t eip,cs,eflags,sp,ss;*/
};
#define SS(x) *(int*)((void*)(x)+ss_idx)
#define ESP(x) *(int*)((void*)(x)+sp_idx)
#define EFLAGS(x) *(int*)((void*)(x)+eflags_idx)
#define CS(x) *(int*)((void*)(x)+cs_idx)
#define EIP(x) *(int*)((void*)(x)+eip_idx)
extern volatile int eip_idx,cs_idx,eflags_idx,sp_idx,ss_idx;
extern volatile struct savedData* progData;
extern  void DebuggerInterrupt();
extern void doFullSaveState(int intNum,int tr,int ss,int ss_offset);
extern void kill();
typedef struct {
	word_t type :2 ;/*0x0 for instr,0x1 for write , 0x3 for r/w */
	word_t enable :1;/*enabled or not. */
	int offset; /*=pc for instr,  =data offset frm ds for data. */
	int debugRegNum; /*which dr is this one using */
}breakPointInfo;
extern volatile int fromThread;
#define BREAK_WRITE 0x1
#define BREAK_RW 0x3
#define BREAK_INSTR 0x0
#define MAX_BREAK 4
#define BREAK_TYPE(x) ((x)==BREAK_INSTR?"instr":((x)==BREAK_RW?"rw":"write"))
#endif 
