; Original file Copyright (c) 2001, David H. Hovemeyer <daveho@cs.umd.edu>
; $Revision: 1.9 $


; A lot of this code is adapted from Kernel Toolkit 0.2
; and Linux version 2.2.x, so the following copyrights apply:

; Copyright (C) 1991, 1992 Linus Torvalds
; adapted for Kernel Toolkit by Luigi Sgro

%ifndef DEFS_ASM
%define DEFS_ASM

; BIOS loads the boot sector at offset 0 in this segment
BOOTSEG equ 0x07C0

; Put the setup sector at the bottom of memory, just above
; the BIOS data. This places a 27k limit on setup code.
SETUPSEG equ 0x100
NUM_SETUP_SECTORS equ 1
NUM_KERN_SECTORS equ 100
; Load our "Kernel" at this segment, which starts at 64K.
; The number of sectors in the kernel, NUM_KERN_SECTORS,
; will be passed on the command line. Since the ISA memory
; starts at 640k, the kernel is limited to 576k.
KERNSEG equ 0x1000

; Video memory segment
VIDSEG equ 0xb800

; The following information is correct for a 1.44M floppy.
; Yes, I'm hard coding this.
SECTORS_PER_TRACK equ 18
HEADS equ 2
CYLINDERS equ 80

; 8259A PIC initialization codes.
; Source: Linux bootsect.S, and Intel 8259A datasheet

; The most important reason why we reprogram the PICs is to
; route the hardware interrupts through vectors *above*
; those reserved by Intel.  The BIOS (for historical reasons :-)
; routes them such that they conflict with internal processor-generated
; interrupts.

ICW1 equ 0x11		; ICW1 - ICW4 needed, cascade mode, interval=8,
			;   edge triggered. (I think interval is irrelevant
			;   for x86.)
ICW2_MASTER equ 0x20	; put IRQs 0-7 at 0x20 (above Intel reserved ints)
ICW2_SLAVE equ 0x28	; put IRQs 8-15 at 0x28
ICW3_MASTER equ 0x04	; IR2 connected to slave
ICW3_SLAVE equ 0x02	; slave has id 2
ICW4 equ 0x01		; 8086 mode, no auto-EOI, non-buffered mode,
			;   not special fully nested mode

; Kernel code and data segment selectors.
; Keep these up to date with defs.h.
KERNEL_CS equ 1<<3	; kernel code segment is GDT entry 1
KERNEL_DS equ 2<<3	; kernel data segment is GDT entry 2
DUMMY_LDT equ 3<<3	; kernel stack segment is GDT entry 3

LDT_IDX equ 3
KERNEL_TSS_IDX equ 4
THREAD_TSS_IDX equ 5

; Pages for context object and stack for initial kernel thread -
; the one we construct for Main().  Keep these up to date with defs.h.
; We put them at 1MB, for no particular reason.
; KERN_THREAD_OBJ equ (1024*1024)

%endif
