#ifndef _FILE_H_
#define _FILE_H_

#ifndef _DEVICE_H_
#include <device.h>
#endif

typedef struct file_data_
{
	k_dev* dev;
	void* private_data;
	word_t flags;
} file_data;

/* file.c */
int_t close(fileh f);
int_t write(fileh f, char_t ch);
int_t read(fileh f, char_t* ch);
int_t write_R(fileh f, void* p, ulong_t rec);
int_t read_R(fileh f, void* p, ulong_t rec);
int_t ioctl2(fileh f, ulong_t request, void* param);

/* ftable.c */
file_data* get_file_data(fileh f);
void release_file(fileh f);
file_data* get_free_file(fileh* f);
void InitFileTable();

/* ioctl macro to simplify calling */
#define ioctl(a, b, c) ioctl2(a, b, (void*)c)

/* values for file_data::flags */
#define FILE_FREE 1

#endif /* !_FILE_H_ */
