%ifndef UTIL_ASM
%define UTIL_ASM

PrintHex:
	pusha
	mov   cx, 4      	
.PrintDigit:
	rol   dx, 4      
   	mov   ax, 0E0Fh	
   	and   al, dl
   	add   al, 90h
   	daa	
   	adc   al, 40h
   	daa
   	int   10h
   	loop  .PrintDigit
	popa
   	ret

; Print the dword contained in the edx register to the screen.
PrintHex8:
	pusha
	mov   cx, 8     
.PrintDigit:
	rol   edx, 4   
   	mov   ax, 0E0Fh
   	and   al, dl
   	add   al, 90h
   	daa	
   	adc   al, 40h
   	daa
   	int   10h
   	loop  .PrintDigit
	popa
   	ret

; Print a newline.
PrintNL:			; print CR and NL
	push	ax
	mov	ax, 0E0Dh	; CR
       	int	10h
       	mov	al, 0Ah		; LF
       	int	10h
	pop	ax
       	ret

     ;*************************************************************************
     ; PROCEDURE DisplayString
     ; display ASCIIZ string at ds:si via BIOS
     ;*************************************************************************
     DisplayString:
          lodsb                                       ; load next character
          or      al, al                              ; test for NUL character
          jz      .DONE
          mov     ah, 0x0E                            ; BIOS teletype
          mov     bh, 0x00                            ; display page 0
          mov     bl, 0x07                            ; text attribute
          int     0x10                                ; invoke BIOS
          jmp     DisplayString
     .DONE:
          ret

%endif
