
#ifndef _VIDEO_H_
#define _VIDEO_H_
#include <stdtypes.h>
#include <memory.h>
#define VID_BLACK   0
#define VID_BLUE    1
#define VID_GREEN   2
#define VID_CYAN    3
#define VID_RED     4
#define VID_MAGENTA 5
#define VID_AMBER   6
#define VID_GRAY	7
#define VID_BRIGHT	8
#define VID_ATTRIB(b,f) ((f)|((b)<<4))

/* public functions */
count_t VidWrite(cstring_t buffer);
count_t VidClear();
void VidSetAttr(byte_t attr);
byte_t VidGetAttr();
void VidMove(byte_t x, byte_t y);
void InitVideo();

/* new video driver stuff */
#define VIDEO_DEVICE 2

typedef struct __VidParams
{
	byte_t rows, cols;
} VidParams;

#define VID_SET_CURSOR	1
#define VID_GET_CURSOR	2
#define VID_GET_PARAMS	3

/* new */
#define VID_SCROLL_HELPER	4

/*///////////////////////////////////////////////////////// */
/* private definitions */

/* video memory information */
#define VID_START ((char_t*)VIDEO_MEM_START)
#define VID_NCOLS 80
#define VID_NROWS 25
/* 80 * 25  records*/
#define VID_NRECORDS (VID_NCOLS * VID_NROWS)

/* video port i/o constants, taken from GeekOS */
#define VID_AREG 0x3D4
#define VID_DREG 0x3D5
#define VID_CURSOR_LOC_HIGH_REG 0x0E
#define VID_CURSOR_LOC_LOW_REG 0x0F

struct __cursor
{
	byte_t x, y, attr;
};
extern  struct __cursor cursor;
#endif /* !_VIDEO_H_ */
