#include <debugger.h>

volatile struct savedData* progData ;
volatile int eip_idx,cs_idx,eflags_idx,sp_idx,ss_idx;
byte_t isErrorCode[]={0,0,0,0,0,0,0,0,1,0,1,1,1,1,1,0,0};
byte_t numErrorCode=17;
volatile int fromThread;
int isThread;
int progLoaded;
extern  void displayTss(){
	printk("\n eax=%x,ebx=%x,ecx=%x,edx=%x,esi=%x,edi=%x,esp=%x,ebp=%x\neflags=%x,eip=%x\nds=%x,gs=%x,fs=%x,es=%x,cs=%x,ss=%x,esp0=%x,ss0=%x,ldt=%x",THREAD_TSS->eax,THREAD_TSS->ebx,THREAD_TSS->ecx,THREAD_TSS->edx,THREAD_TSS->esi,THREAD_TSS->edi,THREAD_TSS->esp,THREAD_TSS->ebp,THREAD_TSS->eflags,THREAD_TSS->eip,THREAD_TSS->ds,THREAD_TSS->gs,THREAD_TSS->fs,THREAD_TSS->es,THREAD_TSS->cs,THREAD_TSS->ss,THREAD_TSS->esp0,THREAD_TSS->ss0,THREAD_TSS->ldt);
}
void displayProgData(){
	/*
IMP: Take care while changing the esp or ss also , the same rules shall apply
	 */
	dword_t ss,esp,eflags,cs,eip;
	if(fromThread){
		printk("\n eax=%x,ebx=%x,ecx=%x,edx=%x,esi=%x,edi=%x,esp=%x,ebp=%x\neflags=%x,eip=%x\nds=%x,gs=%x,fs=%x,es=%x,cs=%x,ss=%x",progData->ax,progData->bx,progData->cx,progData->dx,progData->si,progData->di,ESP(progData),progData->bp,EFLAGS(progData),EIP(progData),progData->ds,progData->gs,progData->fs,progData->es,CS(progData),SS(progData));
	}else 
		printk("\n eax=%x,ebx=%x,ecx=%x,edx=%x,esi=%x,edi=%x,esp=%x,ebp=%x\neflags=%x,eip=%x\nds=%x,gs=%x,fs=%x,es=%x,cs=%x,ss=%x",THREAD_TSS->eax,THREAD_TSS->ebx,THREAD_TSS->ecx,THREAD_TSS->edx,THREAD_TSS->esi,THREAD_TSS->edi,THREAD_TSS->esp,THREAD_TSS->ebp,THREAD_TSS->eflags,THREAD_TSS->eip,THREAD_TSS->ds,THREAD_TSS->gs,THREAD_TSS->fs,THREAD_TSS->es,THREAD_TSS->cs,THREAD_TSS->ss);
}
void run(){
	CLEAR_BIT(TF_BIT,THREAD_TSS->eflags);
	if(fromThread) CLEAR_BIT(TF_BIT,EFLAGS(progData));
	displayProgData();
	switch_to(threadTss.sel<<3);
}
int _i;
breakPointInfo points[MAX_BREAK];
int nBreakPoints;
char ptrArray[100][100];
mem_t threadCode,threadStack,threadData;
int createWordList(char* s){
	int i;
	char* c;
	c=strtok(s," \t");
	i=0;
	while(c){
		strcpy(ptrArray[i],c);
		c=strtok(NULL," \t");
		i++;
	}
	return i; 
}
/* Kill the loaded prog */
void kill(){
	isThread=KERNEL_TYPE;
	fromThread=0;
	progLoaded=0;
	setupDebugReg();
	nBreakPoints=0;
/*	progData=0;
	eip_idx=0;
	ss_idx=0;
	sp_idx=0;
	cs_idx=0;
	eflags_idx=0;*/
	free_mem(&threadCode);
	free_mem(&threadStack);
	free_mem(&threadData);
}
/* Load a program */
void load(int start,int size,int dsSize,int stackSize,int ispriv){
	printk("\n In the load function ");
	setupDebugReg();
	int startBlock=start>>9;
	enum privilege priv=USER;
	int startOffset=start&((1<<9)-1);
	int endBlockNo=(start+size-1)>>9;
	int numBlockReq=endBlockNo-startBlock+1;
	printk("\n About to do the jingo");
	printk("\n Num of blocks reqd is %d",numBlockReq);
	printk("\nDid the jingo ...");
	int numPageReq=BLOCK2PAGE(numBlockReq);
	char* c=(char*)pgAlloc_c(numPageReq);
	if(ispriv) {priv=KERNEL ;printk("\n Warning , running code at kernel priv, you are on your own now");}
	isThread=ispriv?USER_PRIV:USER_UNPRIV;
	printk("\n c= %x",(void*)c);
	printk("\n Num of pages reqd is %d",numPageReq);
	memset(c,0,numPageReq*PAGE_SIZE);
	int i;
	char* cx=c;
	if(stackSize<=0) stackSize=1;
	if(dsSize<=0) dsSize=1;
	/*reading code from floppy */
	for(i=startBlock;i<=endBlockNo;i++){
		printk("\n Going to read sector %d",i);
		FloppyRead(i);
		memcpy(cx,(char*)DMA_START_ADDR,512);
		cx+=512;
	}
	printk("\n Read the floppy ");
	/*freeing the alloced threadCode,threadData,threadStack */
	printk("\n The suspects are %d,%d,%d",threadCode.npage,threadStack.npage,threadData.npage);
	/*PRINT_BITMAP */
	fromThread=0;
	free_mem(&threadCode);
	free_mem(&threadStack);
	free_mem(&threadData);
	printk("\n Freed memory %d",size);
	
	threadCode.npage=((size-1)>>12)+1;
	printk("\n Allocating %d pages for code",threadCode.npage);
	threadCode.page=pgAlloc_c(threadCode.npage);
	printk("\n threadCode.page =%x",(void*)threadCode.page);
	threadCode.sel=installSegment(threadCode.page,PAGE_SIZE*threadCode.npage,CODE,priv);

	threadStack.npage=stackSize;
	printk("\n Allocating %d pages for stack",threadStack.npage);
	threadStack.page=pgAlloc_c(threadStack.npage);
	threadStack.sel=installSegment(threadStack.page,PAGE_SIZE*threadStack.npage,DATA,priv);
	
	threadData.npage=dsSize;
	printk("\n Allocating %d pages for data",threadData.npage);
	threadData.page=pgAlloc_c(dsSize);
	threadData.sel=installSegment(threadData.page,PAGE_SIZE*threadData.npage,DATA,priv);
	
	buildThreadTSS(threadCode,threadData,threadStack);
	
	printk("\n Code/Data/Stack sizes are %d,%d,%d, with selectors %x,%x,%x",threadCode.npage,threadData.npage,threadStack.npage,threadCode.sel,threadData.sel,threadStack.sel);
	printk("\n Size=%d,startOffset=%d,c=%d,threadCode.page=%x,threadData.page=%x,threadStack.page=%x",size,startOffset,(int)c,(int)(threadCode.page),threadData.page,threadStack.page);
	memcpy(threadCode.page,c+startOffset,size);
	pgRelease_c(c,numPageReq);
	printk("\n Executing this \n");
	for(c=(char*)threadCode.page;c<512+(char*)threadCode.page; c++) printk("%x",(byte_t)(*c));
	/*PRINT_BITMAP */
	progLoaded=1;
}
void step(){
	if(fromThread) {
		printk("\n From thread ... ,no clearing ");
		SET_BIT(TF_BIT,EFLAGS(progData));
		/*CLEAR_BIT(RF_BIT,EFLAGS(progData));*/
	}
	else SET_BIT(TF_BIT,THREAD_TSS->eflags);
	displayProgData();
	switch_to(threadTss.sel<<3);
}
void breakOn(int type,int offset){
	int i;
	if(nBreakPoints>=MAX_BREAK) {
		printk("\n Sorry only a maximum of %d breakpoints are allowed ",MAX_BREAK);
		return;
	}
	for(i=0;i<nBreakPoints;i++) if(points[i].type==type && points[i].offset==offset){
		printk("\nThis break point is already set , with no. %d",i+1);
		return;
	}
	int high=(type==BREAK_INSTR ? threadCode.npage << PAGE_SHIFT : threadData.npage<<PAGE_SHIFT);
	breakPointInfo* p= &(points[nBreakPoints]);
	int sel=(type==BREAK_INSTR? THREAD_TSS->cs:THREAD_TSS->ds) & 0xffff;
	dword_t linearAddr=getLinear(sel,offset);
	p->debugRegNum=doBreakOn(type,linearAddr);
	p->type=type&0x3;
	p->enable=0x1;
	p->offset=offset;
	nBreakPoints++;
}
void displayBreakPoints(){
	int i;
	for(i=0;i<nBreakPoints;i++)
		printk("\n No.: %d ,Type: %s ,Enabled: %d ,Offset: %x",i+1,BREAK_TYPE(points[i].type),points[i].enable,points[i].offset);
}
void enableBreakPoint(int n){
	n--;
	if(n<0||n>=nBreakPoints) {printk("Illegal break point no entered"); return;}
	enableBreakReg(points[n].debugRegNum);
	points[n].enable=1;	
}
void disableBreakPoint(int n){
	n--;
	if(n<0||n>=nBreakPoints) {printk("Illegal break point no entered"); return;}
	disableBreakReg(points[n].debugRegNum);
	points[n].enable=0;	
}
void removeBreakPoint(int n){
	int i;
	n--;
	if(n<0||n>=nBreakPoints) {printk("Illegal break point no entered"); return;}
	disableBreakReg(points[i].debugRegNum);
	for(i=n;i<nBreakPoints;i++) points[i-1]=points[i];
	nBreakPoints--;
}
/* This funx might have to move to some other place */
#define SPD sizeof(struct savedData)
void doFullSaveState(int intNum,int tr,int ss,int ss_offset){
	int errorCode,stackSwitched;
	errorCode=(intNum<numErrorCode)?isErrorCode[intNum]:0;
	fromThread=(tr==(THREAD_TSS_IDX<<3));
	progData=(struct savedData*)getLinear(ss,ss_offset);
	stackSwitched=(fromThread?((isThread==USER_PRIV)?0:1):0);
	if(stackSwitched){
		if(errorCode){
			eflags_idx=12;
			eip_idx=4;
			cs_idx=8;
			sp_idx=16;
			ss_idx=20;
		}else{
			eflags_idx=8;
			eip_idx=0;
			cs_idx=4;
			sp_idx=12;
			ss_idx=16;
		}
		sp_idx+=SPD;
		ss_idx+=SPD;
	}else {
		sp_idx=32;
		ss_idx=0;
		if(!errorCode){
			eip_idx=0;
			cs_idx=4;
			eflags_idx=8;
		}else {
			eip_idx=4;
			cs_idx=8;
			eflags_idx=12;
		}
	}
	cs_idx+=SPD;
	eip_idx+=SPD;
	eflags_idx+=SPD;
}
void setRegister(char* regName,int value){
	if(!stricmp(regName,"eax")) {
		if(fromThread) progData->ax=value;
		else THREAD_TSS->eax=value;
	}else if(!stricmp(regName,"ebx")) {
		if(fromThread) progData->bx=value;
		else THREAD_TSS->ebx=value;
	}else if(!stricmp(regName,"ecx")) {
		if(fromThread) progData->cx=value;
		else THREAD_TSS->ecx=value;
	}else if(!stricmp(regName,"edx")) {
		if(fromThread) progData->dx=value;
		else THREAD_TSS->edx=value;
	}else if(!stricmp(regName,"esi")) {
		if(fromThread) progData->si=value;
		else THREAD_TSS->esi=value;
	}else if(!stricmp(regName,"edi")) {
		if(fromThread) progData->di=value;
		else THREAD_TSS->edi=value;
	}else if(!stricmp(regName,"ebp")) {
		if(fromThread) progData->bp=value;
		else THREAD_TSS->ebp=value;
	}else if(!stricmp(regName,"esp")) {
		if(fromThread) ESP(progData)=value;
		else THREAD_TSS->esp=value;
	}else {
		printk("\n Wrong register name entered ...");
	}
}
int createRoSeg(int selno,int base,int limit){
	printk("\n Creating ro seg with this %d,%x,%x",selno,base,limit);
	if((gdtGet(selno))->present) return -1;
	else installSegmentAt(selno,base,limit,DATA,USER);
	(gdtGet(selno))->type=0;/* Read Only Data ...*/
	return 0;
}
void showFreeEntries(){
	int a=0;
	int i;
	for(i=1;(i<GDT_NUM_ENTRIES)&&(a<10);i++){
		if((gdtGet(i))->present) continue;
		a++;
		printk("\n %d: Descriptor not present",i);
	}
}
void displayGdt(int lastIdx){
	int i;
	gdtEntry* entry;	
	dword_t base,limit;
	if(lastIdx>GDT_NUM_ENTRIES) lastIdx=GDT_NUM_ENTRIES;
	for(i=1;i<lastIdx;i++){
		entry=gdtGet(i);
		if(entry->present){
			base=((entry->baseHigh)<<24)|(entry->baseLow);
			limit=((entry->sizeHigh)<<16)|(entry->sizeLow);
			printk("\n%d: Fields are : %x,%x,%x,%x",i,(entry->baseLow)&0xffff,(entry->baseHigh)&0xffff,(entry->sizeLow)&0xffff,(entry->sizeHigh)&0xffff);
			printk("\n %d: Desc info : \n type=%x \t base=%8x \t limit=%5x \t gran=%s \t segtype=%s \t dpl=%d \t availBit=%x \t dbBit=%x" ,i,entry->type,base,limit,(entry->granularity?"true":"false"),(entry->system?"code/data":"system"),entry->dpl,(entry->avail)&0x1,(entry->dbBit)&0x1);
		}
		else printk("\n %d: Descriptor not present",i);
	}
}
void startdebugger(){
	int i=0;
	fromThread=0;
	progLoaded=0;
	isThread=KERNEL_TYPE;
	nBreakPoints=0;
	InstallHandler(1,DebuggerInterrupt);
	InstallHandler(3,DebuggerInterrupt);
	buildKernelTSS();
	initThreadTSS();
	init_prog_seg()
	char* buf=(char*)pgAlloc();
	int codeSize=0;
	/*the below would be done in the load funx. */
/*	char** ptrArray=(char** )pgAlloc();*/
	/*ptrArray[i] is the ptr to the ith word. */
	int args[8];/*max seven args, 1 to 7 */
	while(1){
		printk("\n[La Debugger]>> ");
		gets(buf,PAGE_SIZE);
		/*printk("\n >>%s<<",buf); */
		/*while(1); */
		int numWords=createWordList(buf);/*,ptrArray);	 */
		/*for(i=0;i<numWords;i++) printk("Word %dth is %s ",i,ptrArray[i]); */
		/*printk("\n NumWords is %d",numWords); */
		if(numWords<=0 || numWords>7) {
			printk("\n ***Wrong num of args or bad command \n");
			continue;
		}
		if(!stricmp(ptrArray[0],"load")){
			/*parse load args and call load */
			/*load <startbyte> <size> <dsSize> <stackSize> <ispriv>*/
			CHECK_ARGS_LEN(5)	
			for(i=1;i<=5;i++){
		/*		printk("\n The string thing is %s",ptrArray[i]); */
				args[i]=(int)(atoi(ptrArray[i]));
			}
		/*	printk("\n The args you entered are %d,%d,%d,%d",args[1],args[2],args[3],args[4]); */
			if(args[1]<0||(args[1]+args[2])>MAX_FLOPPY_BYTES||args[2]<=0) ILLEGAL_ARGS
			load(args[1],args[2],args[3],args[4],args[5]);
			codeSize=args[2];
		}else if(!stricmp(ptrArray[0],"step")){
			check_load()
			step(); /*change run to run default , step to trace */
			displayProgData();
		}else if(!stricmp(ptrArray[0],"run")){
			check_load()
			run(); /*change run to run default , step to trace */
			displayProgData();
		}else if(!stricmp(ptrArray[0],"showtss")){
			check_load();
			displayTss();	
		}else if(!stricmp(ptrArray[0],"break")){
			check_load(); /*break <type> <offset> */
			for(i=0;i<numWords;i++) printk(" %d : %s",i,ptrArray[i]);
			CHECK_ARGS_LEN(2)	
			if(!stricmp(ptrArray[1],"instr")) args[1]=BREAK_INSTR;
			else if(!stricmp(ptrArray[1],"write")) args[1]=BREAK_WRITE;
			else if(!stricmp(ptrArray[1],"rw")) args[1]=BREAK_RW;
			else {
				printk("\n Illegal break point type specified , valid ones are instr,write,rw");
				continue;
			}
			args[2]=(int)(atoi(ptrArray[2]));
			breakOn(args[1],args[2]); /*type,offset */
		}else if(!stricmp(ptrArray[0],"showbreak")){
			displayBreakPoints();	
		}else if(!stricmp(ptrArray[0],"clearbreak")){
			check_load();
			args[1]=(int)(atoi(ptrArray[1]));
			removeBreakPoint(args[1]);
		}else if(!stricmp(ptrArray[0],"disablebreak")){
			check_load();/*disablebreak <bNum>*/
			CHECK_ARGS_LEN(1);
			args[1]=(int)(atoi(ptrArray[1]));
			disableBreakPoint(args[1]);
		}else if(!stricmp(ptrArray[0],"roseg")){
			check_load();/*roseg selNo baseInHex limitInHex*/
			CHECK_ARGS_LEN(3);
			args[1]=(int)(atoi(ptrArray[1]));
			args[2]=(int)(atoh(ptrArray[2]));
			args[3]=(int)(atoh(ptrArray[3]));
			if(createRoSeg(args[1],args[2],args[3])<0){
				printk("\n Sorry this segment is not allowed , check teh free segments by printing the gdt table");
			}
		}else if(!stricmp(ptrArray[0],"enablebreak")){
			check_load();
			CHECK_ARGS_LEN(1);/*enablebreak <bNum>*/
			args[1]=(int)(atoi(ptrArray[1]));
			enableBreakPoint(args[1]);
		}else if(!stricmp(ptrArray[0],"kill")){
			check_load();
			kill();	
		}else if(!stricmp(ptrArray[0],"displaygdt")){
			args[1]=(numWords==1)?10:(int)(atoi(ptrArray[1]));
			displayGdt(args[1]);	
		}else if(!stricmp(ptrArray[0],"showfreeentries")){
			showFreeEntries();	
		}else if(!stricmp(ptrArray[0],"set")){
			check_load();/*set <regName> <valueInInt>*/
			CHECK_ARGS_LEN(2)
			args[2]=(int)(atoi(ptrArray[2]));
			setRegister(ptrArray[1],args[2]);	
		}else if(!stricmp(ptrArray[0],"dump")){
			check_load();
			displayProgData();	
		}else if(!stricmp(ptrArray[0],"cls")){
			clearScreen();
		}else if(!stricmp(ptrArray[0],"exit")){
			printk("\n You kidding me , this is an OS sonny , wanna quit ,press the big red switch !! \n");
			break;
		}else
			printk("\n Bad command entered , valid commands are load ,run,showtss,dump,exit");
	}
/*	pgRelease(ptrArray); */
	pgRelease(buf);

	while(1);
}

