#include "main.h"

void pgTest(void);
void panic(cstring_t message);
void TestFloppy(void);
void printk_test(void);
void scanf_test(void);

extern 
void Main(BootInfo* bootInfo)
{
	VidSetAttr(0x07);		/* white on black */
	VidClear();
	
	VidWrite("Bootable protected mode debugger.... v0.1 -CopyRight Devesh Agrawal ");
	VidWrite("Booting...\n\n");

	InitPG();
	InitGDT();
	InitIDT();
	InitLDT();	
	

	InitFileTable();
	InitDeviceTable();

	InitFloppy();

	InitKeyboard();
	dosti();

	InitVideo();
	InitConsole();
	init_printk();
	/*PRINT_BITMAP */
/*	printk_test(); */
	startdebugger();
/*	scanf_test(); */
	/*TestFloppy(); */
/*	FloppyRead(0); */
	while(1);
/*	panic("Code should never reach here!"); */
	
}

void pgTest()
{	
	ptr_t p[10];
	count_t i = 0;

	VidWrite("Testing the page allocator... ");

	while (i < 10)
		p[i++] = pgAlloc();

	pgRelease(p[5]);
	pgRelease(p[4]);
	pgRelease(p[3]);
	pgRelease(p[7]);
	pgRelease(p[8]);
	pgRelease(p[0]);
	pgRelease(p[2]);
	pgRelease(p[1]);
	pgRelease(p[9]);
	pgRelease(p[6]);

	VidWrite("Done\n");
}


void panic(cstring_t message)
{
	VidSetAttr(0x47);		/* white on red */
	VidWrite("Kernel Panic: ");
	VidWrite(message);
	printk("\n %d",_ctr_alloc);
	printk("\n %d",_ctr_release);
	docli();
	while(1)
		donop();
}
void TestFloppy(){
	VidWrite("\n");
	count_t i = 0;
/*	printk("\n Trying to read the first block"); */
/*	FloppyRead(0); */
	#if 0
	char* c=(char*)0x90000;
	for(i=0;i<512;i++) printk("\%x",*(c+i));
	while(1);
	while (i < 2880)
	{
		printk("\n Trying to read the block no. %d",i);
		FloppyRead(i);	/* test the whole damn disk */
		/*PrintHexLong(i++); */
		/*VidWrite("\n"); */
	}
	/* just test a couple of sectors */
	#endif
	clearScreen();
	printk("\n Now reading the sector 0");
	FloppyRead(0);
	char* c=(char*)0x90000;
	for(i=0;i<512;i++) printk(" %x",(byte_t)(*(c+i)));
	scanf("%d",&i);
	printk("\n Now reading the sector 1");
	FloppyRead(1);
	c=(char*)0x90000;
	for(i=0;i<512;i++) printk(" %x",(byte_t)(*(c+i)));
	/*
	VidWrite("-");
	FloppyRead(60);
	VidWrite("-");
	FloppyRead(300);
	VidWrite("-");
	FloppyRead(1200);
	VidWrite("-");
	FloppyRead(2800);*/
}
#define PRINT_LINES 30
void printk_test(){
	int i;
	for(i=0;i<PRINT_LINES;i++){
		printk("\n Cand you print this %d ",i);
	}
}
void scanf_test(){
	printk("\n Enter something cool now");
	char buf[255];
	scanf("%s",buf);
	/*gets(buf,255); */
	printk("\n \n Here is the cool stuff %s",buf);
}

