
#include <stdtypes.h>

#include <kalloc.h>

/* copy from source to dest */
ptr_t memcpy(ptr_t dest, cptr_t src, count_t count)
{
	byte_t* pSrc = (byte_t*)src;
	byte_t* pDest = (byte_t*)dest;

	while (count--)
		*pDest++ = *pSrc++;

	return dest;
}

ptr_t memset(ptr_t dest, byte_t c, count_t count)
{
	byte_t* p = (byte_t*)dest;

	while (count--)
		*p++ = c;

	return dest;
}

int_t memcmp(cptr_t p1, cptr_t p2, count_t count)
{
	byte_t* pa1 = (byte_t*)p1;
	byte_t* pa2 = (byte_t*)p2;
	while (count--)
	{
		if (!(*pa1 == *pa2))
			return ((int_t)*pa2) - ((int_t)*pa1);
		pa1++;
		pa2++;
	}
	return 0;
}
