
#include <stdtypes.h>

#include <video.h>

void PrintHex(unsigned_t c)
{
	byte_t high = (c >> 4) & 0x0F;
	byte_t low = c & 0x0F;
	char_t x[2];

	x[1] = 0;

	VidWrite("0x");

	if (high < 0x0A)
		x[0] = '0' + high;
	else
		x[0] = 'A' + (high - 0x0A);

	VidWrite(x);

	if (low < 0x0A)
		x[0] = '0' + low;
	else
		x[0] = 'A' + (low - 0x0A);

	VidWrite(x);
}

void PrintBin(unsigned_t xx)
{
	byte_t c = (byte_t)(xx & 0xFF);
	
	VidWrite((c & 0x80) ? "1" : "0");
	VidWrite((c & 0x40) ? "1" : "0");
	VidWrite((c & 0x20) ? "1" : "0");
	VidWrite((c & 0x10) ? "1" : "0");
	VidWrite((c & 0x08) ? "1" : "0");
	VidWrite((c & 0x04) ? "1" : "0");
	VidWrite((c & 0x02) ? "1" : "0");
	VidWrite((c & 0x01) ? "1" : "0");
}

void PrintHexLong(ulong_t c) /* 32-bit */
{
	char_t x[2];
	byte_t high, low, cur;

	x[1] = 0;

	VidWrite("0x");

	count_t i = 4;	/* 4 bytes to print */
	while (i--)
	{
		cur = (byte_t)((c & 0xFF000000) >> 24);
		high = (cur & 0xF0) >> 4;
		low = cur & 0x0F;

		if (high < 0x0A)
			x[0] = '0' + high;
		else
			x[0] = 'A' + (high - 0x0A);
		VidWrite(x);

		if (low < 0x0A)
			x[0] = '0' + low;
		else
			x[0] = 'A' + (low - 0x0A);
		VidWrite(x);

		c <<= 8;
	}
}

