/* pad.c : Pads a file to a given size in bytes or sectors*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
void usage(){
	fprintf(stderr,"\n pad [-ns] file [numBytes/numSectors]");
	exit(1);
}
int main(int argc,char** argv){
	int fileSize;
	int padTo;
	int fileIdx;
	int numZero;
	FILE* p;
/*	fprintf(stderr,"\n Entered %d args" , argc);*/
	if(argc!=3 && argc!=4) usage();
	fileIdx=1;
	if(!strcmp(argv[1],"-ns")){
		sscanf(argv[3],"%d",&padTo);
		padTo=padTo<<9;
		fileIdx=2;
	}else sscanf(argv[2],"%d",&padTo);
	if(!(p=fopen(argv[fileIdx],"a+"))){
		fprintf(stderr,"\n Fatal Error , can't open file %s",argv[fileIdx]);
		return 1;
	}
	if(fseek(p,0,SEEK_END)<0){
		fprintf(stderr,"\nError in seeking to end of file");
		return 1;
	}
	fileSize=ftell(p);	
	if(fileSize>padTo){
		fprintf(stderr,"\n Error : padSize is less than file size");
		return 2;
	}
/*	fprintf(stderr,"\n padTo is %d,fileSize=%d",padTo,fileSize);*/
	numZero=padTo-fileSize;
	for(;numZero;numZero--) fprintf(p,"%c",NULL);
	fclose(p);
	return 0;
}
